//---------------------------------------------------------------------------
#ifndef StormUH
#define StormUH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <FGwin.h>

//---------------------------------------------------------------------------
#define IRAND(min,max) ((rand()%(max-min+1))+min)

// size of the highlighted area (actually an oval)
#define GlowWidth 300
#define GlowHeight 200

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published: // IDE-managed Components
   void __fastcall FormActivate(TObject *Sender);
   void __fastcall FormCreate(TObject *Sender);
   void __fastcall FormDestroy(TObject *Sender);
   void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
   void __fastcall FormPaint(TObject *Sender);
private:
   virtual void __fastcall CreateParams(TCreateParams &Params);
   void __fastcall Intro(void);
   void __fastcall MakeOpacityBitmap(void);
   HDC      hDC;
   HPALETTE hPal;
public:
   __fastcall TForm1(TComponent* Owner);
   class Flash *Flash1, *Flash2;
   BYTE Opacity[GlowWidth*GlowHeight]; // opacity bitmap
   BOOL SoundOn;                  // toggles sound effects
};

class Flash
{
private:
   int x1, x2, y1, y2;
   double GammaValue;
   int CountDown;

   // direct color bitmaps
   BYTE Foreground[GlowWidth*GlowHeight*3];
   BYTE Bolt[340*300];

   void Blit(void);
   void CalcAction(struct _node *node);
   void CalcFlash(void);
   void HideFlash(void);
   void ShowFlash(void);
   void ShowBolt(struct _node *node);

   // action functions: (for state machine model)
   static void EndFlash(class Flash *flash);
   static void Flashing0(class Flash *flash);
   static void Flashing1(class Flash *flash);
   static void Flashing2(class Flash *flash);
   static void Flashing3(class Flash *flash);
   static void StartFlash(class Flash *flash);
   static void Waiting(class Flash *flash);

public:
   Flash(void);
   void (*Action)(class Flash *flash);
   int Left, Right, Top, Bottom;
   int BoltLeft, BoltRight, BoltTop, BoltBottom;
   int BoltWidth, BoltHeight;
};

// structure for lightning

#define END      0
#define CONTINUE 1
#define BRANCH   2

typedef struct _node   // for branching electric bolt
{
   int x;
   int y;
   int action;         // END, CONTINUE or BRANCH
   int distance;
} Node;

Node root;

//---------------------------------------------------------------------------
// globals

extern PACKAGE TForm1 *Form1;

// Builder seems to prefer the timer callback function be a static global function
static void CALLBACK AnimProc(UINT uTimerID,UINT uMsg,DWORD dwUser,DWORD dw1, DWORD dw2);
static MMRESULT m_timerID1 = NULL; // used by the timer callback

int vbHandle, vbExtra;
int StopAll;

#endif
